<template>
  <div id="app">
    <h1>Test de binding two-ways d'un objet en utilisant la méthode "watch"</h1>
    <hr>
    Contenu de l'objet:<br>
    <pre>{{ JSON.stringify(value, null, 4) }}</pre>
    <!-- <Sub :value="value" @input="input" /> -->
    <SubProps v-model="value" style="border: solid 1px #000000" />
    <br>
    <SubWatch v-model="value" style="border: solid 1px #000000" />
    <br>
    <button @click="value.field = 'A'">Set to 'A'</button>
    <button @click="value.field = 'B'">Set to 'B'</button>
  </div>
</template>

<script>
import SubProps from './components/Sub-props.vue'
import SubWatch from './components/Sub-watch.vue'

export default {
  components: {
    SubProps,
    SubWatch,
  },
  data() {
    return {
      value: {
        field: 'test',
      },
    };
  },
  methods: {
    input(newVal) {
      console.log('Main - input event catched', newVal);
      this.value = newVal;
    }
  },
  watch: {
    value(newValue) {
      console.log('Main - value watcher triggered', newValue);
    }
  }
}
</script>
